#include "gpio.h"
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>

static char path[64];
static char cmd[128];
static char * one = "1";
static char * zero = "0";

int enable_gpio(int * fd, int gpio_index) {
  FILE *fp;
  char gpio_state_str[16];
  int gpio_state = 0;

  sprintf(path, "/sys/class/gpio/gpio%d/value", gpio_index);
  sprintf(cmd, "cat %s", path);

  fp = popen(cmd, "r");
  if (fp == NULL) {
    fprintf(stderr, "Error when reading gpio\n");
    exit(EXIT_FAILURE);
  }

  while (fgets(gpio_state_str, sizeof(gpio_state_str), fp) != NULL) {
    gpio_state = atoi(gpio_state_str);
  }

  pclose(fp);

  *fd = open(path, O_WRONLY);

  return gpio_state;
}

int toggle_gpio(int fd, int gpio_state) {

  if(gpio_state)
        write(fd, zero, 1);
  else
        write(fd, one, 1);

  gpio_state = !gpio_state;

  return gpio_state;
}
